    001/*
    002    Licensed to the Apache Software Foundation (ASF) under one
    003    or more contributor license agreements.  See the NOTICE file
    004    distributed with this work for additional information
    005    regarding copyright ownership.  The ASF licenses this file
    006    to you under the Apache License, Version 2.0 (the
    007    "License"); you may not use this file except in compliance
    008    with the License.  You may obtain a copy of the License at
    009
    010       http://www.apache.org/licenses/LICENSE-2.0
    011
    012    Unless required by applicable law or agreed to in writing,
    013    software distributed under the License is distributed on an
    014    "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015    KIND, either express or implied.  See the License for the
    016    specific language governing permissions and limitations
    017    under the License.
    018 */
    019package org.apache.wiki.htmltowiki.syntax;
    020
    021import org.apache.wiki.htmltowiki.XHtmlElementToWikiTranslator;
    022import org.jdom2.Element;
    023import org.jdom2.JDOMException;
    024
    025import java.io.PrintWriter;
    026
    027
    028/**
    029 * Translates to wiki syntax from a plain text handling bold.
    030 */
    031public abstract class PlainTextBoldDecorator {
    032
    033    final protected PrintWriter out;
    034    final protected XHtmlElementToWikiTranslator chain;
    035    final protected PlainTextItalicDecorator ptid;
    036
    037    protected PlainTextBoldDecorator( final PlainTextItalicDecorator ptid, final PrintWriter out, final XHtmlElementToWikiTranslator chain ) {
    038        this.out = out;
    039        this.chain = chain;
    040        this.ptid = ptid;
    041    }
    042
    043    /**
    044     * Translates the given XHTML element into wiki markup.
    045     *
    046     * @param dto XHTML element being translated.
    047     */
    048    public void decorate( final XHtmlElementToWikiTranslator.ElementDecoratorData dto ) throws JDOMException {
    049        if( dto.bold ) {
    050            out.print( markupBoldOpen() );
    051        }
    052        ptid.decorate( dto );
    053        if( dto.bold ) {
    054            out.print( markupBoldClose() );
    055        }
    056    }
    057
    058    /**
    059     * Translates the given XHTML element into wiki markup.
    060     *
    061     * @param e XHTML element being translated.
    062     */
    063    public void decorate( final Element e ) throws JDOMException {
    064        out.print( markupBoldOpen() );
    065        chain.translate( e );
    066        out.print( markupBoldClose() );
    067    }
    068
    069    /**
    070     * Opening wiki markup for a bold element.
    071     *
    072     * @return Opening wiki markup for a bold element.
    073     */
    074    protected abstract String markupBoldOpen();
    075
    076    /**
    077     * Closing wiki markup for a bold element.
    078     *
    079     * @return Closing wiki markup for a bold element.
    080     */
    081    protected abstract String markupBoldClose();
    082
    083}